//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrSilver
#property indicator_color3  clrSandyBrown
#property indicator_color4  clrSilver
#property indicator_color5  clrSandyBrown
#property indicator_color6  clrSandyBrown
#property indicator_color7  clrDodgerBlue
#property indicator_color8  clrDodgerBlue
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3
#property indicator_width8  3
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame     = PERIOD_CURRENT;// Time frame to use
extern int             pperiod       = 32;            // Calculating period
extern enPrices        pprice        = pr_close;      // Price
extern int             psmooth       = 32;            // Price smoothing
extern ENUM_MA_METHOD  psmoothMethod = MODE_EMA;      // Price smoothing method
extern int             linesWidth    =  3;            // Lines width
extern int             flLookBack    =  25;           // Floating levels look back period
extern double          flUpLevel     =  90;           // Floating level upper %
extern double          flDnLevel     =  10;           // Floating level lower %
extern bool            alertsOn        = true;        // Turn alerts on?
extern bool            alertsOnCurrent = false;       // Alerts on currnt (still opened) bar?
extern bool            alertsMessage   = true;        // Alerts should show pop-up message?
extern bool            alertsSound     = false;       // Alerts should play alert sound?
extern bool            alertsPushNotif = false;       // Alerts should send push notification?
extern bool            alertsEmail     = false;       // Alerts should send email?
extern bool            Interpolate   = true;          // Interpolate in multi time frame mode?


double buffer[];
double bufferda[];
double bufferdb[];
double bufferua[];
double bufferub[];
double flup[];
double flmi[];
double fldn[];
double trend[];
double prices[];
double pricer[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,flup,    INDICATOR_DATA);
   SetIndexBuffer(1,flmi,    INDICATOR_DATA);
   SetIndexBuffer(2,fldn,    INDICATOR_DATA);
   SetIndexBuffer(3,buffer,  INDICATOR_DATA); SetIndexStyle(3,EMPTY,EMPTY,linesWidth);
   SetIndexBuffer(4,bufferda,INDICATOR_DATA); SetIndexStyle(4,EMPTY,EMPTY,linesWidth);
   SetIndexBuffer(5,bufferdb,INDICATOR_DATA); SetIndexStyle(5,EMPTY,EMPTY,linesWidth);
   SetIndexBuffer(6,bufferua,INDICATOR_DATA); SetIndexStyle(6,EMPTY,EMPTY,linesWidth);
   SetIndexBuffer(7,bufferub,INDICATOR_DATA); SetIndexStyle(7,EMPTY,EMPTY,linesWidth);
   SetIndexBuffer(8,trend   ,INDICATOR_CALCULATIONS);
   SetIndexBuffer(9,prices  ,INDICATOR_CALCULATIONS);
   SetIndexBuffer(10,pricer ,INDICATOR_CALCULATIONS);
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame==-99;
            TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" cci experiment ("+(string)pperiod+","+(string)psmooth+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-2);
            if (returnBars) { flup[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != Period())
            {
               if (trend[limit]==-1) CleanPoint(limit,bufferda,bufferdb);
               if (trend[limit]== 1) CleanPoint(limit,bufferua,bufferub);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  flup[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,pperiod,pprice,psmooth,psmoothMethod,flLookBack,flUpLevel,flDnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,0,y);
                  flmi[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,pperiod,pprice,psmooth,psmoothMethod,flLookBack,flUpLevel,flDnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,1,y);
                  fldn[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,pperiod,pprice,psmooth,psmoothMethod,flLookBack,flUpLevel,flDnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,2,y);
                  buffer[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,pperiod,pprice,psmooth,psmoothMethod,flLookBack,flUpLevel,flDnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,3,y);
                  trend[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,pperiod,pprice,psmooth,psmoothMethod,flLookBack,flUpLevel,flDnLevel,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,6,y);
                  bufferda[i] = EMPTY_VALUE;
                  bufferdb[i] = EMPTY_VALUE;
                  bufferua[i] = EMPTY_VALUE;
                  bufferub[i] = EMPTY_VALUE;
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                     {
                           buffer[i+k] = buffer[i] + (buffer[i+n] - buffer[i]) * k/n;
                           flup[i+k]   = flup[i]   + (flup[i+n]   - flup[i]  ) * k/n;
                           flmi[i+k]   = flmi[i]   + (flmi[i+n]   - flmi[i]  ) * k/n;
                           fldn[i+k]   = fldn[i]   + (fldn[i+n]   - fldn[i]  ) * k/n;
                     }                           
               }
               for(int i=limit; i>=0; i--)
               {
                  if (trend[i] == -1) PlotPoint(i,bufferda,bufferdb,buffer);
                  if (trend[i] ==  1) PlotPoint(i,bufferua,bufferub,buffer);
               }                  
               return(0);
            }

   //
   //
   //
   //
   //

   if (trend[limit]==-1) CleanPoint(limit,bufferda,bufferdb);
   if (trend[limit]== 1) CleanPoint(limit,bufferua,bufferub);
   for(int i=limit; i>=0; i--) pricer[i] = getPrice(pprice,Open,Close,High,Low,i);
   for(int i=limit; i>=0; i--)
   {
      prices[i] = pricer[i]-iMAOnArray(pricer,0,psmooth,0,psmoothMethod,i);
         double avgs = 0; for(int k=0; k<pperiod && (i+k)<Bars; k++) avgs +=         prices[i+k];       avgs /= pperiod;
         double devs = 0; for(int k=0; k<pperiod && (i+k)<Bars; k++) devs += MathAbs(prices[i+k]-avgs); devs /= pperiod;
            if (devs!=0)
                  buffer[i] = (prices[i]-avgs)/(0.015*devs);
            else  buffer[i] = 0;

      //
      //
      //
      //
      //
         
      bufferda[i] = EMPTY_VALUE;
      bufferdb[i] = EMPTY_VALUE;
      bufferua[i] = EMPTY_VALUE;
      bufferub[i] = EMPTY_VALUE;
      trend[i]    = 0;
         double min   = buffer[ArrayMinimum(buffer,flLookBack,i)];
         double max   = buffer[ArrayMaximum(buffer,flLookBack,i)];
         double range = max-min;
            fldn[i] = min+range*flDnLevel/100.0;
            flup[i] = min+range*flUpLevel/100.0;
            flmi[i] = min+range*0.5;
      
         //
         //
         //
         //
         //
         
         if (buffer[i]>flup[i]) trend[i] =  1;
         if (buffer[i]<fldn[i]) trend[i] = -1;
         if (trend[i] == -1) PlotPoint(i,bufferda,bufferdb,buffer);
         if (trend[i] ==  1) PlotPoint(i,bufferua,bufferub,buffer);
   }      
      
      //
      //
      //
      //
      //
   
      if (alertsOn)
      {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1) doAlert(whichBar,"up");
           if (trend[whichBar] == -1) doAlert(whichBar,"down");
        }
      }        
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}   

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(_Period)+" - "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" CCI detrended experiment trend changed to "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(Symbol()+" CCI experiment",message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}